/*Napisite funkciju mind koja prima prirodni broj n ≤ 19 i cjelobrojnu matricu tipa (n + 1) × n, te iz
matrice izbaci jedan redak, tako da dobivena kvadratna matrica reda n ima maksimalan trag. Ako takvih redaka ima vise,
izbacite zadnjeg od njih. Napisite odsjecak glavnog programa: deklaraciju matrice za sve dozvoljene n, te poziv funkcije na
toj matrici za n = 9.*/

#include<stdio.h>

void mind(int x[20][19], int n)
{
    int maks,i,j,t=0;
    for(i=0;i<n+1;i++)   /* za i-ti ignorirani redak racunamo trag preostale kvadratne matrice */
    {
        int trag=0;
        for(j=0;j<n;j++)  trag+=x[j+(j<i ? 0:1)][j]; /*pomak u indeksu retka za 1 ako dodemo do stupca i */
        if((i==0) || (maks <= trag)) {maks=trag; t=i;}
    }

    while(t<=n)
    {
        for(j=0;j<n;j++) x[t][j]=x[t+1][j]; /* izbacivanje t-tog retka */
        t++;
    }

}

void ucitaj(int x[20][19], int n)
{
    int i,j;
    for(i=0;i<n+1;i++)
        for(j=0;j<n;j++)  { printf("x[%d][%d]=",i,j); scanf("%d",&x[i][j]); }
}

void ispisi(int x[20][19], int n)
{
    int i,j;
    for(i=0;i<n;i++) { printf("\n");
        for(j=0;j<n;j++) printf("%d ",x[i][j]); }
    printf("\n");
}



int main(void)
{
    int x[20][19], n;
    printf("n="); scanf("%d",&n); printf("\n");
    ucitaj(x,n);
    mind(x,n);
    ispisi(x,n);
    return 0;
}
