#include <stdio.h>
#include <stdlib.h>

int main(void){
    int i, j, n, *b, indeks_najboljeg;
    double **sprint, najbolje_vrijeme, prosjek;

    printf("Ucitajte broj trkaca...");
    scanf("%d", &n);

    sprint = (double**) malloc(n*sizeof(double*));
    b = (int*) malloc(n*sizeof(int));

    /*U matrici "sprint" cuvamo podatke o vremenima; sprint[i] je i-ti redak
    - u njemu cuvamo podatke o i-tom trkacu. Duljine redaka cuvamo u nizu b.*/

    for(i = 0; i < n; ++i){
        printf("Ucitajte broj sprinteva trkaca pod rednim brojem %d\n", i);
        scanf("%d", &b[i]);
        sprint[i] = (double*) malloc(b[i]*sizeof(double)); //alociramo memoriju za i-ti redak
        printf("Ucitavajte rezultate sprinteva:\n");
        for(j = 0; j < b[i]; ++j) scanf("%lf", &sprint[i][j]);
    }

    //tablica je ucitana, trazimo najbolje vrijeme:
    najbolje_vrijeme = sprint[0][0];
    for(i = 0; i < n; ++i)
        for(j = 0; j < b[i]; ++j)
            if(sprint[i][j] < najbolje_vrijeme){
                najbolje_vrijeme = sprint[i][j];
                indeks_najboljeg = i;
            }
    prosjek = 0;
    for(j = 0; j < b[indeks_najboljeg]; ++j) prosjek += sprint[indeks_najboljeg][j];
    prosjek /= b[indeks_najboljeg];

    printf("Najbrze vrijeme ostvario je trkac pod rednim brojem %d. Njegovo prosjecno vrijeme je %g.\n", indeks_najboljeg, prosjek);

    for(i = 0; i < n; ++i) free(sprint[i]);
    free(sprint);
    free(b);
    return 0;
}
