#include <stdio.h>
#include <stdlib.h>

int main(void){
    int i, j, n, *r;
    int **racuni, indeks_najboljeg;
    double zarada = 0, max_zarada, ukupna_zarada = 0;

    printf("Ucitajte broj dana...");
    scanf("%d", &n);

    racuni = (int**) malloc(n*sizeof(int*));
    r = (int*) malloc(n*sizeof(int));

    /*U matrici "racuni" cuvamo podatke o iznosima racuna; racuni[i] je i-ti redak
    - u njemu cuvamo podatke o i-tom danu. Duljine redaka cuvamo u nizu r.*/

    for(i = 0; i < n; ++i){
        printf("Ucitajte broj racuna za dan %d\n", i);
        scanf("%d", &r[i]);
        racuni[i] = (int*) malloc(r[i]*sizeof(int)); //alociramo memoriju za i-ti redak
        printf("Ucitavajte iznose racuna:\n");
        for(j = 0; j < r[i]; ++j) scanf("%d", &racuni[i][j]);
    }

    //tablica je ucitana, trazimo dan s najboljom zaradom;
    //najprije inicijaliziramo
    for(j = 0; j < r[0]; ++j) zarada += racuni[0][j];
    indeks_najboljeg = 0;
    max_zarada = zarada;
    ukupna_zarada += zarada;

    for(i = 1; i < n; ++i){
        zarada = 0;
        for(j = 0; j < r[i]; ++j) zarada += racuni[i][j];
        if(zarada > max_zarada){
            max_zarada = zarada;
            indeks_najboljeg = i;
        }
        ukupna_zarada += zarada;
    }

    printf("Najveca zarada ostvarena je u danu %d. Prosjecna dnevna zarada je %g.\n", indeks_najboljeg, ukupna_zarada/n);

    for(i = 0; i < n; ++i) free(racuni[i]);
    free(racuni);
    free(r);
    return 0;
}
