#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char* kodiraj(const char* str, const char* v, const char* w)
{
    char *novistr;
    int i, j;

    novistr=(char*)malloc((strlen(str)+1));

    for(i=0; i<=strlen(str); i++){
        novistr[i]=str[i];  //umjesto ove linije koda smo mogli izvan petlje napisati strcpy(novistr,str)
        for(j=0; j<strlen(v); j++){
            if(novistr[i]==v[j]){
            novistr[i]=w[j];
            break;
            }
        }
    }

    return novistr;
}

char* provjeri(const char* str, const char* v, const char* w)
{
    if(strlen(str)%3)
        return NULL;

    char *a, *b, *c, *abc;
    int i;

    a=(char*)malloc(strlen(str)/3+1);
    memcpy(a,str,strlen(str)/3);
    a[strlen(str)/3]='\0';  //memcpy ne stavlja '\0' na kraj!
//    for(i=0; i<strlen(str)/3; i++){
//        a[i]=str[i];
//    }
//    a[i]='\0';

    b=kodiraj(a,v,w); //cuvamo adresu da mozemo osloboditi memoriju kasnije
    c=kodiraj(b,v,w);

    abc=(char*)malloc(strlen(str)+1);
    strcpy(abc,a);
    strcat(abc,b);
    strcat(abc,c);

    free(b);
    free(c);

    if(strcmp(str,abc)==0){
        free(abc);
        return a;
    }

    else{
        free(abc);
        free(a);
        return NULL;
    }
}

////Rjesenje bez pomocnog stringa abc
//char* provjeri(const char* str, const char* v, const char* w)
//{
//    if(strlen(str)%3)
//        return NULL;
//
//    char* a, *b, *c;
//    int i;
//
//    a=(char*)malloc(strlen(str)/3+1);
//    for(i=0; i<strlen(str)/3; i++){
//        a[i]=str[i];
//    }
//    a[i]='\0';
//
//    b=kodiraj(a,v,w); //cuvamo adresu da mozemo osloboditi memoriju kasnije
//    c=kodiraj(b,v,w);
//
//    for(i=0; i<strlen(str)/3; i++){
//        if(b[i]!=str[i+strlen(str)/3] || c[i]!=str[i+2*strlen(str)/3])
//            break;
//    }
//
//    free(b);
//    free(c);
//
//    if(i<strlen(str)/3){
//        free(a);
//        return NULL;
//    }
//
//    return a;
//}

int main(void)
{
    char v[]="abce", w[]="efgh";
    char s[]="mammemmhm", *a;

    a=provjeri(s,v,w);
    if(a)
        printf("a=\"%s\"\n", a);

    return 0;
}
