#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char* prevedi(const char* str, const char* x, const char* y)
{
    char *novistr;
    int i, j;

    novistr=(char*)malloc((strlen(str)+1));

    for(i=0; i<=strlen(str); i++){
        novistr[i]=str[i];  //umjesto ove linije koda smo mogli izvan petlje napisati strcpy(novistr,str)
        for(j=0; j<strlen(x); j++){
            if(novistr[i]==x[j]){
            novistr[i]=y[j];
            break;
            }
        }
    }

    return novistr;
}

char* provjeri(const char* str, const char* x, const char* y)
{
    if(strlen(str)%3)
        return NULL;

    char *a, *b, *c, *abc;
    int i;

    c=(char*)malloc(strlen(str)/3+1);
    strcpy(c,str+2*strlen(str)/3);
//    for(i=0; i<strlen(str)/3; i++){
//        c[i]=str[i+2*strlen(str)/3];
//    }
//    c[i]='\0';

    b=prevedi(c,x,y); //cuvamo adresu da mozemo osloboditi memoriju kasnije
    a=prevedi(b,x,y);

    abc=(char*)malloc(strlen(str)+1);
    strcpy(abc,a);
    strcat(abc,b);
    strcat(abc,c);

    free(a);
    free(b);

    if(strcmp(str,abc)==0){
        free(abc);
        return c;
    }

    else{
        free(abc);
        free(c);
        return NULL;
    }
}

////Rjesenje bez pomocnog stringa abc
//char* provjeri(const char* str, const char* x, const char* y)
//{
//    if(strlen(str)%3)
//        return NULL;
//
//    char* a, *b, *c;
//    int i;
//
//    c=(char*)malloc(strlen(str)/3+1);
//    strcpy(c,str+2*strlen(str)/3);
////    for(i=0; i<strlen(str)/3; i++){
////        c[i]=str[i+2*strlen(str)/3];
////    }
////    c[i]='\0';
//
//    b=prevedi(c,x,y); //cuvamo adresu da mozemo osloboditi memoriju kasnije
//    a=prevedi(b,x,y);
//
//    for(i=0; i<strlen(str)/3; i++){
//        if(a[i]!=str[i] || b[i]!=str[i+strlen(str)/3])
//            break;
//    }
//
//    free(a);
//    free(b);
//
//    if(i<strlen(str)/3){
//        free(c);
//        return NULL;
//    }
//
//    return c;
//}

int main(void)
{
    char x[]="au", y[]="ui";
    char s[]="pirpurpar", *c;

    c=provjeri(s,x,y);
    if(c)
        printf("c=\"%s\"\n", c);

    return 0;
}
