#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char* kodiraj(const char* str, const char* p, const char* q)
{
    char *novistr;
    int i, j;

    novistr=(char*)malloc((strlen(str)+1));

    for(i=0; i<=strlen(str); i++){
        novistr[i]=str[i];  //umjesto ove linije koda smo mogli izvan petlje napisati strcpy(novistr,str)
        for(j=0; j<strlen(p); j++){
            if(novistr[i]==p[j]){
            novistr[i]=q[j];
            break;
            }
        }
    }

    return novistr;
}

char* provjeri(const char* str, const char* p, const char* q)
{
    if(strlen(str)%3)
        return NULL;

    char *A, *B, *C, *ABC;
    int i;

    C=(char*)malloc(strlen(str)/3+1);
    strcpy(C,str+2*strlen(str)/3);
//    for(i=0; i<strlen(str)/3; i++){
//        C[i]=str[i+2*strlen(str)/3];
//    }
//    C[i]='\0';

    A=kodiraj(C,p,q); //cuvamo adresu da mozemo osloboditi memoriju kasnije
    B=kodiraj(A,p,q);

    ABC=(char*)malloc(strlen(str)+1);
    strcpy(ABC,A);
    strcat(ABC,B);
    strcat(ABC,C);

    free(A);
    free(B);

    if(strcmp(str,ABC)==0){
        free(ABC);
        return C;
    }

    else{
        free(ABC);
        free(C);
        return NULL;
    }
}

////Rjesenje bez pomocnog stringa ABC
//char* provjeri(const char* str, const char* p, const char* q)
//{
//    if(strlen(str)%3)
//        return NULL;
//
//    char *A, *B, *C;
//    int i;
//
//    C=(char*)malloc(strlen(str)/3+1);
//    strcpy(C,str+2*strlen(str)/3);
////    for(i=0; i<strlen(str)/3; i++){
////        C[i]=str[i+2*strlen(str)/3];
////    }
////    C[i]='\0';
//
//    A=kodiraj(C,p,q); //cuvamo adresu da mozemo osloboditi memoriju kasnije
//    B=kodiraj(A,p,q);
//
//    for(i=0; i<strlen(str)/3; i++){
//        if(A[i]!=str[i] || B[i]!=str[i+strlen(str)/3])
//            break;
//    }
//
//    free(A);
//    free(B);
//
//    if(i<strlen(str)/3){
//        free(C);
//        return NULL;
//    }
//
//    return C;
//}

int main(void)
{
    char p[]="eu", q[]="uo";
    char s[]="putpotpet", *C;

    C=provjeri(s,p,q);
    if(C)
        printf("C=\"%s\"\n", C);

    return 0;
}

