#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char* prevedi(const char* str, const char* r, const char* s)
{
    char *novistr;
    int i, j;

    novistr=(char*)malloc((strlen(str)+1));

    for(i=0; i<=strlen(str); i++){
        novistr[i]=str[i];  //umjesto ove linije koda smo mogli izvan petlje napisati strcpy(novistr,str)
        for(j=0; j<strlen(r); j++){
            if(novistr[i]==r[j]){
            novistr[i]=s[j];
            break;
            }
        }
    }

    return novistr;
}

char* provjeri(const char* str, const char* r, const char* s)
{
    if(strlen(str)%3)
        return NULL;

    char *A, *B, *C, *ABC;
    int i;

    B=(char*)malloc(strlen(str)/3+1);
    memcpy(B,str+strlen(str)/3,strlen(str)/3);
    B[strlen(str)/3]='\0';
//    for(i=0; i<strlen(str)/3; i++){
//        B[i]=str[i+strlen(str)/3];
//    }
//    B[i]='\0';

    C=prevedi(B,r,s); //cuvamo adresu da mozemo osloboditi memoriju kasnije
    A=prevedi(C,r,s);

    ABC=(char*)malloc(strlen(str)+1);
    strcpy(ABC,A);
    strcat(ABC,B);
    strcat(ABC,C);

    free(A);
    free(C);

    if(strcmp(str,ABC)==0){
        free(ABC);
        return B;
    }

    else{
        free(ABC);
        free(B);
        return NULL;
    }
}

////Rjesenje bez pomocnog stringa ABC
//char* provjeri(const char* str, const char* r, const char* s)
//{
//    if(strlen(str)%3)
//        return NULL;
//
//    char *A, *B, *C;
//    int i;
//
//    B=(char*)malloc(strlen(str)/3+1);
//    memcpy(B,str+strlen(str)/3,strlen(str)/3);
//    B[strlen(str)/3]='\0';
////    for(i=0; i<strlen(str)/3; i++){
////        B[i]=str[i+strlen(str)/3];
////    }
////    B[i]='\0';
//
//    C=prevedi(B,r,s); //cuvamo adresu da mozemo osloboditi memoriju kasnije
//    A=prevedi(C,r,s);
//
//    for(i=0; i<strlen(str)/3; i++){
//        if(A[i]!=str[i] || C[i]!=str[i+2*strlen(str)/3])
//            break;
//    }
//
//    free(A);
//    free(C);
//
//    if(i<strlen(str)/3){
//        free(B);
//        return NULL;
//    }
//
//    return B;
//}

//char* provjeri(const char* str, const char* p, const char* q)
//{
//    if(strlen(str)%3)
//        return NULL;
//
//    char *A, *B, *C;
//    int i;
//
//    C=(char*)malloc(strlen(str)/3+1);
//    strcpy(C,str+2*strlen(str)/3);
////    for(i=0; i<strlen(str)/3; i++){
////        C[i]=str[i+2*strlen(str)/3];
////    }
////    C[i]='\0';
//
//    A=kodiraj(C,p,q); //cuvamo adresu da mozemo osloboditi memoriju kasnije
//    B=kodiraj(A,p,q);
//
//    for(i=0; i<strlen(str)/3; i++){
//        if(A[i]!=str[i] || B[i]!=str[i+strlen(str)/3])
//            break;
//    }
//
//    free(A);
//    free(B);
//
//    if(i<strlen(str)/3){
//        free(C);
//        return NULL;
//    }
//
//    return C;
//}

int main(void)
{
    char r[]="lp", s[]="ps";
    char str[]="setletpet", *B;

    B=provjeri(str,r,s);
    if(B)
        printf("B=\"%s\"\n", B);

    return 0;
}


