/* Napisite funkciju mind koja prima prirodni broj n ≤ 10 i cjelobrojnu matricu tipa n × (n + 1), te iz
matrice izbaci jedan stupac, tako da dobivena kvadratna matrica reda n ima minimalan trag. Ako takvih stupaca ima vise,
izbacite zadnjeg od njih. Napisite odsjecak glavnog programa: deklaraciju matrice za sve dozvoljene n, te poziv funkcije na
toj matrici za n = 5.*/


#include<stdio.h>

void mind(int x[10][11], int n)
{
    int min,i,j,t=0;
    for(j=0;j<n+1;j++)   /* za j-ti ignorirani stupac racunamo trag preostale kvadratne matrice */
    {
        int trag=0;
        for(i=0;i<n;i++)  trag+=x[i][i+(i<j ? 0:1)]; /*pomak u indeksu stupca za 1 ako dodemo do retka j */
        if((j==0) || (min >= trag)) {min=trag; t=j;}
    }

    while(t<=n)
    {
        for(i=0;i<n;i++) x[i][t]=x[i][t+1]; /* izbacivanje t-tog stupca */
        t++;
    }

}

void ucitaj(int x[10][11], int n)
{
    int i,j;
    for(i=0;i<n;i++)
        for(j=0;j<n+1;j++)  { printf("x[%d][%d]=",i,j); scanf("%d",&x[i][j]); }
}

void ispisi(int x[10][11], int n)
{
    int i,j;
    for(i=0;i<n;i++) { printf("\n");
        for(j=0;j<n;j++) printf("%d ",x[i][j]); }
    printf("\n");
}



int main(void)
{
    int x[10][11], n;
    printf("n="); scanf("%d",&n); printf("\n");
    ucitaj(x,n);
    mind(x,n);
    ispisi(x,n);
    return 0;
}
