#include <stdio.h>
#include <stdlib.h>

int main(void){
    int i, j, n, *k, indeks_najboljeg;
    double **krugovi, avg, best_avg = 0, najbolje_vrijeme;

    printf("Ucitajte broj bolida...");
    scanf("%d", &n);

    krugovi = (double**) malloc(n*sizeof(double*));
    k = (int*) malloc(n*sizeof(int));

    /*U matrici "krugovi" cuvamo podatke o vremenima; krugovi[i] je i-ti redak
    - u njemu cuvamo podatke o i-tom bolidu. Duljine redaka cuvamo u nizu k.*/

    for(i = 0; i < n; ++i){
        printf("Ucitajte broj krugova za bolid pod rednim brojem %d\n", i);
        scanf("%d", &k[i]);
        krugovi[i] = (double*) malloc(k[i]*sizeof(double)); //alociramo memoriju za i-ti redak
        printf("Ucitavajte rezultate krugova:\n");
        for(j = 0; j < k[i]; ++j) scanf("%lf", &krugovi[i][j]);
    }

    //tablica je ucitana, trazimo najbolji prosjek;
    //najprije inicijaliziramo
    for(j = 0; j < k[0]; ++j) best_avg += krugovi[0][j];
    best_avg /= k[0];
    indeks_najboljeg = 0;

    for(i = 1; i < n; ++i)
        avg = 0;
        for(j = 0; j < k[i]; ++j) avg += krugovi[i][j];
        if(avg < best_avg){
            best_avg = avg;
            indeks_najboljeg = i;
        }
    //trazimo njegovo najbolje vrijeme
    najbolje_vrijeme = krugovi[indeks_najboljeg][0];
    for(j = 1; j < k[indeks_najboljeg]; ++j)
        if(krugovi[indeks_najboljeg][j] < najbolje_vrijeme) najbolje_vrijeme = krugovi[indeks_najboljeg][j];


    printf("Najbolji prosjek ostvario je bolid pod rednim brojem %d. Njegovo najbolje vrijeme je %g.\n", indeks_najboljeg, najbolje_vrijeme);

    for(i = 0; i < n; ++i) free(krugovi[i]);
    free(krugovi);
    free(k);
    return 0;
}
