#include <stdio.h>
#include <stdlib.h>

int main(void){
    int i, j, n, *p;
    int **distance, naj;
    double prosjek;


    printf("Ucitajte broj dana...");
    scanf("%d", &n);

    distance = (int**) malloc(n*sizeof(int*));
    p = (int*) malloc(n*sizeof(int));

    /*U matrici "distance" cuvamo podatke o duljinama relacija; distance[i] je i-ti redak
    - u njemu cuvamo podatke o i-tom danu. Duljine redaka cuvamo u nizu p.*/

    for(i = 0; i < n; ++i){
        printf("Ucitajte broj putovanja za dan %d\n", i);
        scanf("%d", &p[i]);
        distance[i] = (int*) malloc(p[i]*sizeof(int)); //alociramo memoriju za i-ti redak
        printf("Ucitavajte duljine putovanja:\n");
        for(j = 0; j < p[i]; ++j) scanf("%d", &distance[i][j]);
    }

    //tablica je ucitana

    for(i = 0; i < n; ++i){
        prosjek = distance[i][0];
        naj = distance[i][0];
        for(j = 1; j < p[i]; ++j){
                prosjek += distance[i][j];
                if(distance[i][j] > naj) naj = distance[i][j];
        }
    printf("Najduza relacija dana %d bila je %d. Prosjecna duljina putovanja tog dana bila je %g\n", i, naj, prosjek/p[i]);
    }


    for(i = 0; i < n; ++i) free(distance[i]);
    free(distance);
    free(p);
    return 0;
}
